{$G+} {$R+} {$S+}
unit pwormss;
interface
  uses midas,mmem,mplayer,s3m,modp,mparser,sdevice,crt;
  procedure playsample(samplenum:byte);
  procedure mutemusic(on_off:byte);
  procedure muteeffects(on_off:byte);
  procedure initmusic(fname:string);
  procedure deinitmusicsoftware;
  procedure setposition(newpos:byte);
  procedure setmidasoptions(options:string);
  procedure preinitializemidas;
  procedure sndtoggle;
const
  {sample numbers}
  sample_kala:byte=255;
  sample_zppw:byte=1;
  sample_argh:byte=2;
  sample_laugh:byte=3;
  sample_cool:byte=4;
  sample_burp:byte=5;
  sample_jam:byte=6;
  sample_good:byte=7;
  sample_namnam:byte=8;
  sample_hungry:byte=9;
  {Music pattern locations}
  mpl_death:byte=$15;
  mpl_startup:byte=$0E;
  mpl_100score:byte=$10;
  mpl_ingame:byte=$00;
  mpl_hscores:byte=$13;
  mpl_grts:byte=$0E;
  {Module size}
var
  usemidas:boolean;
  midasenabled:boolean;
  musicon:boolean;
  effectson:boolean;
  module:Pmpmodule;
implementation
  procedure playsample(samplenum:byte);
  var
   channel:word;
   sd:psounddevice;
  begin
    sd:=midassd;
    channel:=0;
    if midasenabled then begin
      sd^.setinstrument(channel,samplenum);
      sd^.playsound(0,11000);
    end;
  end;
  procedure muteeffects(on_off:byte);
  var
    sd:psounddevice;
  begin
    sd:=midassd;
    if midasenabled then SD^.mutechannel(0,on_off);
  end;
  procedure mutemusic(on_off:byte);
  var
   sd:psounddevice;
   channel:byte;
   nul:integer;
  begin
    sd:=midassd;
    if midasenabled then for channel:=1 to 4 do nul:=sd^.mutechannel(channel,on_off);
  end;

  procedure initmusic(fname:string);
  var
    result:byte;
    MP:Pmoduleplayer;
    pcharri:pchar;
  function toASCIIZ(dest : PChar; str : string) : PChar;
  var
      spos, slen : integer;
      i : integer;

  begin
      spos := 0;                          { string position = 0 }
      slen := ord(str[0]);                { string length }

      { copy string to ASCIIZ conversion buffer: }
      while spos < slen do
      begin
          dest[spos] := str[spos+1];
          spos := spos + 1;
      end;

    dest[spos] := chr(0);               { put terminating 0 to end of string }

    toASCIIZ := dest;
end;
  begin
    if usemidas then begin
      {$I+}
      midasparseoption('om');
      midasinit;
      module:=midasloadmodule(toasciiz(pcharri,fname),@mpMOD,NIL);
      midasPlayModule(module,1);
      midasenabled:=true;
      mutemusic(1);
      muteeffects(1);
    end
    else
    begin
      midasenabled:=false;
    end;
  end;
  procedure deinitmusicsoftware;
  begin
    midasClose;
  end;
  procedure setposition(newpos:byte);
  var
    MP:Pmoduleplayer;
  begin
    MP:=@mpMOD;
    if midasenabled then MP^.setposition(newpos);
  end;
  procedure setmidasoptions(options:string);
  var
   cs:byte;
   ce:byte;
   optin:string;
   optinpc:pchar;
   conv:byte;
  begin
    cs:=0;
    options:=options+' ';
    for ce:=1 to length(options) do begin
      if options[ce]='&' then cs:=ce+1;
      if ((options[ce]=' ') and (cs<>0)) then begin
        optin:=copy(options,cs,ce-cs);
        for conv:=1 to length(optin) do begin
        optinpc[conv-1]:=optin[conv];
        end;
        optinpc[length(optin)+1]:=chr(0);
        midasparseoption(optinpc);
        cs:=0;
      end;
    end;
    if cs<>0 then begin
        optinpc:=chr(0);
        for conv:=cs to ce do begin
          optinpc[conv-cs]:=options[conv];
        end;
        midasparseoption(optinpc);
    end;
  end;
  procedure preinitializemidas;
  begin
    midassetdefaults;
    setmidasoptions('&b');
    midasDetectSD;
  end;
  procedure sndtoggle;
  begin
    if musicon then begin
      mutemusic(1);
      musicon:=false;
    end
    else
    begin
      mutemusic(0);
      musicon:=true;
    end;
    if effectson then begin
      muteeffects(1);
      effectson:=false;
    end
    else
    begin
      muteeffects(0);
      effectson:=true;
    end;
  end;
end.
